"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _context = require("../context");
var _utils = require("../utils/utils");
var _usePaintHue = require("../hooks/usePaintHue");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var tinycolor = require('tinycolor2');
var AdvancedControls = function AdvancedControls(_ref) {
  var _ref2;
  var openAdvanced = _ref.openAdvanced;
  var _usePicker = (0, _context.usePicker)(),
    tinyColor = _usePicker.tinyColor,
    hue = _usePicker.hue,
    l = _usePicker.l,
    handleChange = _usePicker.handleChange,
    s = _usePicker.s,
    opacity = _usePicker.opacity,
    squareSize = _usePicker.squareSize;
  var _tinyColor$toHsv = tinyColor.toHsv(),
    v = _tinyColor$toHsv.v,
    vs = _tinyColor$toHsv.s;
  var satRef = (0, _react.useRef)(null);
  var lightRef = (0, _react.useRef)(null);
  var brightRef = (0, _react.useRef)(null);
  (0, _usePaintHue.usePaintSat)(satRef, hue, l * 100, squareSize);
  (0, _usePaintHue.usePaintLight)(lightRef, hue, s * 100, squareSize);
  (0, _usePaintHue.usePaintBright)(brightRef, hue, s * 100, squareSize);
  var satDesat = function satDesat(value) {
    var _tinycolor$toRgb = tinycolor({
        h: hue,
        s: value / 100,
        l: l
      }).toRgb(),
      r = _tinycolor$toRgb.r,
      g = _tinycolor$toRgb.g,
      b = _tinycolor$toRgb.b;
    handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
  };
  var setLight = function setLight(value) {
    var _tinycolor$toRgb2 = tinycolor({
        h: hue,
        s: s,
        l: value / 100
      }).toRgb(),
      r = _tinycolor$toRgb2.r,
      g = _tinycolor$toRgb2.g,
      b = _tinycolor$toRgb2.b;
    handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
  };
  var setBright = function setBright(value) {
    var _tinycolor$toRgb3 = tinycolor({
        h: hue,
        s: vs * 100,
        v: value
      }).toRgb(),
      r = _tinycolor$toRgb3.r,
      g = _tinycolor$toRgb3.g,
      b = _tinycolor$toRgb3.b;
    handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(opacity, ")"));
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: openAdvanced ? 98 : 0,
      width: '100%',
      transition: 'all 120ms linear'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: (_ref2 = {
      paddingTop: 11,
      display: openAdvanced ? '' : 'none'
    }, _defineProperty(_ref2, "display", 'flex'), _defineProperty(_ref2, "flexDirection", 'column'), _defineProperty(_ref2, "justifyContent", "space-between"), _defineProperty(_ref2, "height", openAdvanced ? 98 : 0), _defineProperty(_ref2, "overflow", 'hidden'), _ref2)
  }, /*#__PURE__*/_react["default"].createElement(AdvBar, {
    value: s,
    reffy: satRef,
    callback: satDesat,
    openAdvanced: openAdvanced,
    label: "Saturation"
  }), /*#__PURE__*/_react["default"].createElement(AdvBar, {
    value: l,
    reffy: lightRef,
    label: "Lightness",
    callback: setLight,
    openAdvanced: openAdvanced
  }), /*#__PURE__*/_react["default"].createElement(AdvBar, {
    value: v,
    reffy: brightRef,
    label: "Brightness",
    callback: setBright,
    openAdvanced: openAdvanced
  })));
};
var _default = AdvancedControls;
exports["default"] = _default;
var AdvBar = function AdvBar(_ref3) {
  var value = _ref3.value,
    callback = _ref3.callback,
    reffy = _ref3.reffy,
    openAdvanced = _ref3.openAdvanced,
    label = _ref3.label;
  var _usePicker2 = (0, _context.usePicker)(),
    squareSize = _usePicker2.squareSize;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    dragging = _useState2[0],
    setDragging = _useState2[1];
  var _useState3 = (0, _react.useState)(2),
    _useState4 = _slicedToArray(_useState3, 2),
    handleTop = _useState4[0],
    setHandleTop = _useState4[1];
  // const sliderId = `${label?.toLowerCase()}Handle`
  var left = value * (squareSize - 18);
  (0, _react.useEffect)(function () {
    var _reffy$current;
    setHandleTop((reffy === null || reffy === void 0 ? void 0 : (_reffy$current = reffy.current) === null || _reffy$current === void 0 ? void 0 : _reffy$current.offsetTop) - 2);
  }, [openAdvanced, reffy]);
  var stopDragging = function stopDragging() {
    setDragging(false);
  };
  var handleMove = function handleMove(e) {
    if (dragging) {
      callback((0, _utils.getHandleValue)(e));
    }
  };
  var handleClick = function handleClick(e) {
    if (!dragging) {
      callback((0, _utils.getHandleValue)(e));
    }
  };
  var handleDown = function handleDown() {
    setDragging(true);
  };

  // const handleKeyboard = (e) => {
  //   if (inFocus === sliderId && openAdvanced) {
  //       if (e.keyCode === 37) {
  //         const newValue = value * 100 - 1;
  //         callback(Math.max(newValue, 0));
  //       } else if (e.keyCode === 39) {
  //         const newValue = value * 100 + 1;
  //         callback(Math.min(newValue, 100));
  //       }
  //   }
  // }
  //
  // useEffect(() => {
  //   window.addEventListener('keydown', handleKeyboard);
  //
  //   return () => {
  //     window.removeEventListener('keydown', handleKeyboard);
  //   };
  // }, [value, inFocus, openAdvanced]);

  (0, _react.useEffect)(function () {
    var handleUp = function handleUp() {
      stopDragging();
    };
    window.addEventListener('mouseup', handleUp);
    return function () {
      window.removeEventListener('mouseup', handleUp);
    };
  }, []);
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: '100%',
      padding: '3px 0px 3px 0px'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "c-resize ps-rl",
    onMouseMove: function onMouseMove(e) {
      return handleMove(e);
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      left: left,
      top: handleTop
    },
    onMouseDown: handleDown,
    className: "rbgcp-handle"
  }), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      textAlign: 'center',
      color: '#fff',
      fontSize: 12,
      fontWeight: 500,
      lineHeight: 1,
      position: 'absolute',
      left: '50%',
      transform: 'translate(-50%, 0%)',
      top: handleTop + 2,
      zIndex: 10,
      textShadow: '1px 1px 1px rgba(0,0,0,.6)'
    },
    onMouseMove: function onMouseMove(e) {
      return handleMove(e);
    },
    onClick: function onClick(e) {
      return handleClick(e);
    }
  }, label), /*#__PURE__*/_react["default"].createElement("canvas", {
    ref: reffy,
    width: "".concat(squareSize, "px"),
    height: "14px",
    style: {
      position: 'relative',
      borderRadius: 14
    },
    onClick: function onClick(e) {
      return handleClick(e);
    }
  })));
};