"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _context = require("../context");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
var ComparibleColors = function ComparibleColors(_ref) {
  var openComparibles = _ref.openComparibles;
  var _usePicker = (0, _context.usePicker)(),
    tinyColor = _usePicker.tinyColor,
    handleChange = _usePicker.handleChange;
  var analogous = tinyColor.analogous();
  var monochromatic = tinyColor.monochromatic();
  var triad = tinyColor.triad();
  var tetrad = tinyColor.tetrad();
  var handleClick = function handleClick(tiny) {
    var _tiny$toRgb = tiny.toRgb(),
      r = _tiny$toRgb.r,
      g = _tiny$toRgb.g,
      b = _tiny$toRgb.b,
      a = _tiny$toRgb.a;
    handleChange("rgba(".concat(r, ",").concat(g, ",").concat(b, ",").concat(a, ")"));
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      height: openComparibles ? 216 : 0,
      width: '100%',
      transition: 'all 120ms linear'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      paddingTop: 11,
      display: openComparibles ? '' : 'none',
      position: "relative"
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      textAlign: 'center',
      fontSize: 13,
      fontWeight: 600,
      position: 'absolute',
      top: 6.5,
      left: 2
    },
    className: "rbgcp-comparible-label"
  }, "Color Guide"), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      textAlign: 'center',
      fontSize: 12,
      fontWeight: 500,
      marginTop: 3
    },
    className: "rbgcp-comparible-label"
  }, "Analogous"), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      borderRadius: 5,
      overflow: 'hidden',
      display: 'flex'
    }
  }, analogous === null || analogous === void 0 ? void 0 : analogous.map(function (c, key) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: key,
      style: {
        width: '20%',
        height: 30,
        background: c.toHexString()
      },
      onClick: function onClick() {
        return handleClick(c);
      }
    });
  })), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      textAlign: 'center',
      fontSize: 12,
      fontWeight: 500,
      marginTop: 3
    },
    className: "rbgcp-comparible-label"
  }, "Monochromatic"), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      borderRadius: 5,
      overflow: 'hidden',
      display: 'flex',
      justifyContent: "flex-end"
    }
  }, monochromatic === null || monochromatic === void 0 ? void 0 : monochromatic.map(function (c, key) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: key,
      style: {
        width: '20%',
        height: 30,
        background: c.toHexString()
      },
      onClick: function onClick() {
        return handleClick(c);
      }
    });
  })), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      textAlign: 'center',
      fontSize: 12,
      fontWeight: 500,
      marginTop: 3
    },
    className: "rbgcp-comparible-label"
  }, "Triad"), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      borderRadius: 5,
      overflow: 'hidden',
      display: 'flex',
      justifyContent: "flex-end"
    }
  }, triad === null || triad === void 0 ? void 0 : triad.map(function (c, key) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: key,
      style: {
        width: 'calc(100% / 3)',
        height: 28,
        background: c.toHexString()
      },
      onClick: function onClick() {
        return handleClick(c);
      }
    });
  })), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      textAlign: 'center',
      fontSize: 12,
      fontWeight: 500,
      marginTop: 3
    },
    className: "rbgcp-comparible-label"
  }, "Tetrad"), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      borderRadius: 5,
      overflow: 'hidden',
      display: 'flex',
      justifyContent: "flex-end"
    }
  }, tetrad === null || tetrad === void 0 ? void 0 : tetrad.map(function (c, key) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      key: key,
      style: {
        width: '25%',
        height: 28,
        background: c.toHexString()
      },
      onClick: function onClick() {
        return handleClick(c);
      }
    });
  }))));
};
var _default = ComparibleColors;
exports["default"] = _default;