"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.controlBtnStyles = void 0;
var _react = _interopRequireWildcard(require("react"));
var _icon = require("./icon");
var _context = require("../context");
var _EyeDropper = _interopRequireDefault(require("./EyeDropper"));
var _constants = require("../constants");
var _AdvancedControls = _interopRequireDefault(require("./AdvancedControls"));
var _ComparibleColors = _interopRequireDefault(require("./ComparibleColors"));
var _GradientControls = _interopRequireDefault(require("./GradientControls"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
var defaultColor = _constants.config.defaultColor,
  defaultGradient = _constants.config.defaultGradient;
var Controls = function Controls(_ref) {
  var locales = _ref.locales,
    hideEyeDrop = _ref.hideEyeDrop,
    hideAdvancedSliders = _ref.hideAdvancedSliders,
    hideColorGuide = _ref.hideColorGuide,
    hideInputType = _ref.hideInputType,
    hideColorTypeBtns = _ref.hideColorTypeBtns,
    hideGradientControls = _ref.hideGradientControls,
    hideGradientType = _ref.hideGradientType,
    hideGradientAngle = _ref.hideGradientAngle,
    hideGradientStop = _ref.hideGradientStop;
  var _usePicker = (0, _context.usePicker)(),
    isGradient = _usePicker.isGradient,
    internalOnChange = _usePicker.internalOnChange,
    previousColors = _usePicker.previousColors,
    previousGraidents = _usePicker.previousGraidents,
    handleChange = _usePicker.handleChange;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    openAdvanced = _useState2[0],
    setOpenAdvanced = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = _slicedToArray(_useState3, 2),
    openComparibles = _useState4[0],
    setOpenComparibles = _useState4[1];
  var _useState5 = (0, _react.useState)(false),
    _useState6 = _slicedToArray(_useState5, 2),
    openInputType = _useState6[0],
    setOpenInputType = _useState6[1];
  var noTools = hideEyeDrop && hideAdvancedSliders && hideColorGuide && hideInputType;
  var solidColor = (previousColors === null || previousColors === void 0 ? void 0 : previousColors[0]) || defaultColor;
  var gradientColor = (previousGraidents === null || previousGraidents === void 0 ? void 0 : previousGraidents[0]) || defaultGradient;
  var setSolid = function setSolid() {
    internalOnChange(solidColor);
  };
  var setGradient = function setGradient() {
    internalOnChange(gradientColor);
  };
  var allRightControlsHidden = hideEyeDrop && hideAdvancedSliders && hideColorGuide && hideInputType;
  var allControlsHidden = allRightControlsHidden && hideColorTypeBtns;
  if (allControlsHidden) {
    if (isGradient && !hideGradientControls) {
      return /*#__PURE__*/_react["default"].createElement(_GradientControls["default"], {
        hideGradientType: hideGradientType,
        hideGradientAngle: hideGradientAngle,
        hideGradientStop: hideGradientStop
      });
    } else {
      return null;
    }
  } else {
    return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        paddingTop: 12,
        paddingBottom: 4
      }
    }, /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        width: "100%"
      },
      className: "ac jsb"
    }, /*#__PURE__*/_react["default"].createElement(ColorTypeBtns, {
      hideColorTypeBtns: hideColorTypeBtns,
      setGradient: setGradient,
      isGradient: isGradient,
      setSolid: setSolid,
      locales: locales
    }), !allRightControlsHidden && /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        display: noTools ? "none" : ""
      },
      className: "rbgcp-control-btn-wrapper"
    }, !hideEyeDrop && /*#__PURE__*/_react["default"].createElement(_EyeDropper["default"], {
      onSelect: handleChange
    }), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        display: hideAdvancedSliders ? "none" : "flex"
      },
      id: "rbgcp-advanced-btn",
      className: "rbgcp-control-icon-btn rbgcp-advanced-btn ".concat(openAdvanced && "rbgcp-control-btn-selected"),
      onClick: function onClick() {
        return setOpenAdvanced(!openAdvanced);
      }
    }, /*#__PURE__*/_react["default"].createElement(_icon.SlidersIcon, {
      color: openAdvanced ? "#568CF5" : ""
    })), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        display: hideColorGuide ? "none" : "flex"
      },
      id: "rbgcp-comparibles-btn",
      className: "rbgcp-control-icon-btn rbgcp-comparibles-btn ".concat(openComparibles && "rbgcp-control-btn-selected"),
      onClick: function onClick() {
        return setOpenComparibles(!openComparibles);
      }
    }, /*#__PURE__*/_react["default"].createElement(_icon.PaletteIcon, {
      color: openComparibles ? "#568CF5" : ""
    })), /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        display: hideInputType ? "none" : "flex"
      },
      id: "rbgcp-color-model-btn",
      className: "rbgcp-control-icon-btn rbgcp-color-model-btn ".concat(openInputType && "rbgcp-control-btn-selected"),
      onClick: function onClick() {
        return setOpenInputType(!openInputType);
      }
    }, /*#__PURE__*/_react["default"].createElement(_icon.InputsIcon, {
      color: openInputType ? "#568CF5" : ""
    }), /*#__PURE__*/_react["default"].createElement(InputTypeDropdown, {
      openInputType: openInputType,
      setOpenInputType: setOpenInputType
    })))), !hideAdvancedSliders && /*#__PURE__*/_react["default"].createElement(_AdvancedControls["default"], {
      openAdvanced: openAdvanced
    }), !hideColorGuide && /*#__PURE__*/_react["default"].createElement(_ComparibleColors["default"], {
      openComparibles: openComparibles
    }), isGradient && !hideGradientControls && /*#__PURE__*/_react["default"].createElement(_GradientControls["default"], {
      hideGradientType: hideGradientType,
      hideGradientAngle: hideGradientAngle,
      hideGradientStop: hideGradientStop
    }));
  }
};
var _default = Controls;
exports["default"] = _default;
var InputTypeDropdown = function InputTypeDropdown(_ref2) {
  var openInputType = _ref2.openInputType,
    setOpenInputType = _ref2.setOpenInputType;
  var _usePicker2 = (0, _context.usePicker)(),
    inputType = _usePicker2.inputType,
    setInputType = _usePicker2.setInputType;
  var vTrans = openInputType ? "visibility 0ms linear" : "visibility 100ms linear 150ms";
  var zTrans = openInputType ? "z-index 0ms linear" : "z-index 100ms linear 150ms";
  var oTrans = openInputType ? "opacity 120ms linear" : "opacity 150ms linear 50ms";
  var handleInputType = function handleInputType(e, val) {
    if (openInputType) {
      e.stopPropagation();
      setInputType(val);
      setOpenInputType(false);
    }
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      visibility: openInputType ? "visible" : "hidden",
      zIndex: openInputType ? "" : -100,
      opacity: openInputType ? 1 : 0,
      transition: "".concat(oTrans, ", ").concat(vTrans, ", ").concat(zTrans)
    },
    className: "rbgcp-color-model-dropdown"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "rbgcp-control-btn rbgcp-color-model-dropdown-btn ".concat(inputType === "rgb" && "rbgcp-control-btn-selected"),
    onClick: function onClick(e) {
      return handleInputType(e, "rgb");
    }
  }, "RGB"), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rbgcp-control-btn rbgcp-color-model-dropdown-btn ".concat(inputType === "hsl" && "rbgcp-control-btn-selected"),
    onClick: function onClick(e) {
      return handleInputType(e, "hsl");
    }
  }, "HSL"), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rbgcp-control-btn rbgcp-color-model-dropdown-btn ".concat(inputType === "hsv" && "rbgcp-control-btn-selected"),
    onClick: function onClick(e) {
      return handleInputType(e, "hsv");
    }
  }, "HSV"), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rbgcp-control-btn rbgcp-color-model-dropdown-btn ".concat(inputType === "cmyk" && "rbgcp-control-btn-selected"),
    onClick: function onClick(e) {
      return handleInputType(e, "cmyk");
    }
  }, "CMYK"));
};
var ColorTypeBtns = function ColorTypeBtns(_ref3) {
  var hideColorTypeBtns = _ref3.hideColorTypeBtns,
    isGradient = _ref3.isGradient,
    setSolid = _ref3.setSolid,
    setGradient = _ref3.setGradient,
    locales = _ref3.locales;
  if (hideColorTypeBtns) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      style: {
        width: 1
      }
    });
  } else {
    var _locales$CONTROLS, _locales$CONTROLS2;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "rbgcp-control-btn-wrapper"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      onClick: setSolid,
      id: "rbgcp-solid-btn",
      className: "rbgcp-control-btn rbgcp-solid-btn ".concat(!isGradient && "rbgcp-control-btn-selected")
    }, locales === null || locales === void 0 ? void 0 : (_locales$CONTROLS = locales.CONTROLS) === null || _locales$CONTROLS === void 0 ? void 0 : _locales$CONTROLS.SOLID), /*#__PURE__*/_react["default"].createElement("div", {
      onClick: setGradient,
      id: "rbgcp-gradient-btn",
      className: "rbgcp-control-btn rbgcp-gradient-btn ".concat(isGradient && "rbgcp-control-btn-selected")
    }, locales === null || locales === void 0 ? void 0 : (_locales$CONTROLS2 = locales.CONTROLS) === null || _locales$CONTROLS2 === void 0 ? void 0 : _locales$CONTROLS2.GRADIENT));
  }
};
var controlBtnStyles = function controlBtnStyles(selected) {
  return {
    background: selected ? "white" : "rgba(255,255,255,0)",
    color: selected ? "#568CF5" : "",
    boxShadow: selected ? "1px 1px 3px rgba(0,0,0,.2)" : "1px 1px 3px rgba(0,0,0,0)"
  };
};
exports.controlBtnStyles = controlBtnStyles;