"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _context = require("../context");
var _formatters = require("../utils/formatters");
var _Controls = require("./Controls");
var _icon = _interopRequireWildcard(require("./icon"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var GradientControls = function GradientControls(_ref) {
  var hideGradientType = _ref.hideGradientType,
    hideGradientAngle = _ref.hideGradientAngle,
    hideGradientStop = _ref.hideGradientStop;
  var _usePicker = (0, _context.usePicker)(),
    gradientType = _usePicker.gradientType;
  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      marginTop: 12,
      marginBottom: -4,
      paddingLeft: hideGradientType ? 4 : 0
    },
    id: "rbgcp-gradient-controls-wrap",
    className: "rbgcp-control-btn-wrapper jsb"
  }, !hideGradientType && /*#__PURE__*/_react["default"].createElement(GradientType, null), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      width: 53
    }
  }, !hideGradientAngle && gradientType === 'linear-gradient' && /*#__PURE__*/_react["default"].createElement(DegreePicker, null)), !hideGradientStop && /*#__PURE__*/_react["default"].createElement(StopPicker, null), /*#__PURE__*/_react["default"].createElement(DeleteBtn, null));
};
var _default = GradientControls;
exports["default"] = _default;
var GradientType = function GradientType() {
  var _usePicker2 = (0, _context.usePicker)(),
    gradientType = _usePicker2.gradientType,
    internalOnChange = _usePicker2.internalOnChange,
    value = _usePicker2.value;
  var isLinear = gradientType === 'linear-gradient';
  var isRadial = gradientType === 'radial-gradient';
  var handleLinear = function handleLinear() {
    var remaining = value.split(/,(.+)/)[1];
    internalOnChange("linear-gradient(90deg, ".concat(remaining));
  };
  var handleRadial = function handleRadial() {
    var remaining = value.split(/,(.+)/)[1];
    internalOnChange("radial-gradient(circle, ".concat(remaining));
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "rbgcp-control-btn-wrapper"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    onClick: handleLinear,
    id: "rbgcp-linear-btn",
    className: "rbgcp-control-btn rbgcp-linear-btn ".concat(isLinear && "rbgcp-control-btn-selected")
  }, /*#__PURE__*/_react["default"].createElement(_icon.LinearIcon, {
    color: isLinear ? '#568CF5' : ''
  })), /*#__PURE__*/_react["default"].createElement("div", {
    onClick: handleRadial,
    id: "rbgcp-gradient-btn",
    className: "rbgcp-control-btn rbgcp-gradient-btn ".concat(isRadial && "rbgcp-control-btn-selected")
  }, /*#__PURE__*/_react["default"].createElement(_icon.RadialIcon, {
    color: isRadial ? '#568CF5' : ''
  })));
};
var StopPicker = function StopPicker() {
  var _usePicker3 = (0, _context.usePicker)(),
    currentLeft = _usePicker3.currentLeft,
    handleGradient = _usePicker3.handleGradient,
    currentColor = _usePicker3.currentColor;
  var handleMove = function handleMove(newVal) {
    handleGradient(currentColor, (0, _formatters.formatInputValues)(newVal, 0, 100));
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "rbgcp-control-btn-wrapper rbgcp-control-input-wrap rbgcp-stop-input-wrap",
    style: {
      paddingLeft: 8
    }
  }, /*#__PURE__*/_react["default"].createElement(_icon.StopIcon, null), /*#__PURE__*/_react["default"].createElement("input", {
    id: "rbgcp-stop-input",
    value: currentLeft,
    className: "rbgcp-control-input rbgcp-stop-input",
    onChange: function onChange(e) {
      return handleMove(e.target.value || 0);
    }
  }));
};
var DegreePicker = function DegreePicker() {
  var _usePicker4 = (0, _context.usePicker)(),
    degrees = _usePicker4.degrees,
    internalOnChange = _usePicker4.internalOnChange,
    value = _usePicker4.value;
  var handleDegrees = function handleDegrees(e) {
    var newValue = (0, _formatters.formatInputValues)(e.target.value, 0, 360);
    var remaining = value.split(/,(.+)/)[1];
    internalOnChange("linear-gradient(".concat(newValue || 0, "deg, ").concat(remaining));
  };
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "rbgcp-control-btn-wrapper rbgcp-control-input-wrap rbgcp-degree-input-wrap"
  }, /*#__PURE__*/_react["default"].createElement(_icon.DegreesIcon, null), /*#__PURE__*/_react["default"].createElement("input", {
    id: "rbgcp-degree-input",
    value: degrees,
    className: "rbgcp-control-input rbgcp-degree-input",
    onChange: function onChange(e) {
      return handleDegrees(e);
    }
  }), /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      position: 'absolute',
      right: degrees > 99 ? 0 : degrees < 10 ? 7 : 3,
      top: 1,
      fontWeight: 400,
      fontSize: 13
    },
    className: "rbgcp-degree-icon"
  }, "\xB0"));
};
var DeleteBtn = function DeleteBtn() {
  var _usePicker5 = (0, _context.usePicker)(),
    deletePoint = _usePicker5.deletePoint;
  return /*#__PURE__*/_react["default"].createElement("div", {
    onClick: deletePoint,
    style: _objectSpread({
      width: 28
    }, (0, _Controls.controlBtnStyles)(false)),
    id: "rbgcp-point-delete-btn",
    className: "rbgcp-control-icon-btn rbgcp-point-delete-btn"
  }, /*#__PURE__*/_react["default"].createElement(_icon["default"], null));
};