"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _usePaintSquare = _interopRequireDefault(require("../hooks/usePaintSquare"));
var _context = require("../context");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; } // import throttle from 'lodash.throttle'
var Square = function Square() {
  var _usePicker = (0, _context.usePicker)(),
    x = _usePicker.x,
    y = _usePicker.y,
    handleColor = _usePicker.handleColor,
    internalHue = _usePicker.internalHue,
    squareSize = _usePicker.squareSize,
    squareHeight = _usePicker.squareHeight;
  var _useState = (0, _react.useState)(false),
    _useState2 = _slicedToArray(_useState, 2),
    dragging = _useState2[0],
    setDragging = _useState2[1];
  var canvas = (0, _react.useRef)(null);
  (0, _usePaintSquare["default"])(canvas, internalHue, squareSize, squareHeight);
  var handleChange = function handleChange(e) {
    var _canvas$current;
    var ctx = canvas === null || canvas === void 0 ? void 0 : (_canvas$current = canvas.current) === null || _canvas$current === void 0 ? void 0 : _canvas$current.getContext('2d', {
      willReadFrequently: true
    });
    // const onMouseMove = throttle(() => handleColor(e, ctx), 250)
    handleColor(e, ctx);
    // onMouseMove()
  };

  var stopDragging = function stopDragging() {
    setDragging(false);
  };
  var handleMove = function handleMove(e) {
    if (dragging) {
      handleChange(e);
    }
  };
  var handleClick = function handleClick(e) {
    if (!dragging) {
      handleChange(e);
    }
  };
  var handleMouseDown = function handleMouseDown() {
    setDragging(true);
  };
  var handleCanvasDown = function handleCanvasDown(e) {
    setDragging(true);
    handleChange(e);
  };
  (0, _react.useEffect)(function () {
    var handleUp = function handleUp() {
      stopDragging();
    };
    window.addEventListener('mouseup', handleUp);
    return function () {
      window.removeEventListener('mouseup', handleUp);
    };
  }, []);

  // const handleKeyboard = (e) => {
  //   if (inFocus === 'squareHandle') {
  //     const ctx = canvas?.current?.getContext('2d', { willReadFrequently: true })
  //       if (e.keyCode === 37) {
  //         handleColor({ type: 'picker-keyboard', x: Math.max(x - 1, 0), y: y }, ctx);
  //       } else if (e.keyCode === 39) {
  //         handleColor({ type: 'picker-keyboard', x: Math.min(x + 1, 100), y: y }, ctx);
  //       }
  //   }
  // }
  //
  // useEffect(() => {
  //   window.addEventListener('keydown', handleKeyboard);
  //
  //   return () => {
  //     window.removeEventListener('keydown', handleKeyboard);
  //   };
  // }, [value, inFocus, x, y]);

  return /*#__PURE__*/_react["default"].createElement("div", {
    style: {
      position: 'relative'
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "ps-rl c-cross",
    onMouseDown: handleCanvasDown,
    onMouseMove: function onMouseMove(e) {
      return handleMove(e);
    },
    onMouseUp: stopDragging
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "rbgcp-handle",
    style: {
      left: x,
      top: y
    },
    onMouseDown: handleMouseDown
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "rbgcp-canvas-wrapper",
    style: {
      height: squareHeight
    },
    onClick: function onClick(e) {
      return handleClick(e);
    }
  }, /*#__PURE__*/_react["default"].createElement("canvas", {
    ref: canvas,
    width: "".concat(squareSize, "px"),
    height: "".concat(squareHeight, "px"),
    id: "paintSquare"
  }))));
};
var _default = Square;
exports["default"] = _default;